//
// Copyright 2023 Vulcanize, Inc.
//
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import assert from 'assert';
import { Buffer } from 'buffer';
import { pipe } from 'it-pipe';
import * as lp from 'it-length-prefixed';
import map from 'it-map';
import { pushable } from 'it-pushable';
import { fromString as uint8ArrayFromString } from 'uint8arrays/from-string';
import { toString as uint8ArrayToString } from 'uint8arrays/to-string';
import debug from 'debug';
import { createLibp2p } from '@cerc-io/libp2p';
import { webSockets } from '@libp2p/websockets';
import { noise } from '@chainsafe/libp2p-noise';
import { mplex } from '@libp2p/mplex';
import { yamux } from '@chainsafe/libp2p-yamux';
import { createFromJSON, createEd25519PeerId } from '@libp2p/peer-id-factory';
import { multiaddr } from '@multiformats/multiaddr';
import { pubsubPeerDiscovery } from '@libp2p/pubsub-peer-discovery';
import { PrometheusMetrics } from '@cerc-io/prometheus-metrics';
import { MAX_CONCURRENT_DIALS_PER_PEER, MAX_CONNECTIONS, MIN_CONNECTIONS, DIAL_TIMEOUT, PUBSUB_DISCOVERY_INTERVAL, RELAY_TAG, RELAY_REDIAL_INTERVAL, DEFAULT_MAX_RELAY_CONNECTIONS, DEFAULT_PING_TIMEOUT, P2P_CIRCUIT_ID, CHAT_PROTOCOL, DEBUG_INFO_TOPIC, P2P_WEBRTC_STAR_ID } from './constants.js';
import { PeerHearbeatChecker } from './peer-heartbeat-checker.js';
import { debugInfoRequestHandler, dialWithRetry, getConnectionsInfo, getPseudonymForPeerId, getSelfInfo, initPubsub, isMultiaddrBlacklisted, wsPeerFilter } from './utils/index.js';
import { ConnectionType } from './types/debug-info.js';
var log = debug('laconic:peer');
var ERR_PEER_ALREADY_TAGGED = 'Peer already tagged';
var ERR_DEBUG_INFO_NOT_ENABLED = 'Debug info not enabled';
var Peer = /** @class */ (function () {
    function Peer(relayNodeURL, nodejs) {
        this._numRelayConnections = 0;
        this._peerStreamMap = new Map();
        this._messageHandlers = [];
        this._topicHandlers = new Map();
        this._metrics = new PrometheusMetrics();
        this._webRTCSignallingEnabled = !(nodejs === true);
        this._relayNodeMultiaddr = multiaddr(relayNodeURL);
        var relayPeerId = this._relayNodeMultiaddr.getPeerId();
        assert(relayPeerId);
        log("Using peer ".concat(relayPeerId, " (").concat(getPseudonymForPeerId(relayPeerId), ") as the primary relay node"));
    }
    Object.defineProperty(Peer.prototype, "peerId", {
        get: function () {
            var _a;
            return (_a = this._node) === null || _a === void 0 ? void 0 : _a.peerId;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Peer.prototype, "node", {
        get: function () {
            return this._node;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Peer.prototype, "relayNodeMultiaddr", {
        get: function () {
            return this._relayNodeMultiaddr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Peer.prototype, "metrics", {
        get: function () {
            return this._metrics;
        },
        enumerable: false,
        configurable: true
    });
    Peer.prototype.init = function (initOptions, peerIdObj) {
        var _a, _b, _c, _d, _e, _f, _g;
        return __awaiter(this, void 0, void 0, function () {
            var pingTimeout, peerId, webRTCSignal, relayPeerIdString, _h, err_1;
            var _this = this;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        this._relayRedialInterval = initOptions.relayRedialInterval;
                        this._denyMultiaddrs = initOptions.denyMultiaddrs;
                        this._maxRelayConnections = initOptions.maxRelayConnections;
                        this._debugInfoEnabled = initOptions.enableDebugInfo;
                        pingTimeout = (_a = initOptions.pingTimeout) !== null && _a !== void 0 ? _a : DEFAULT_PING_TIMEOUT;
                        _j.label = 1;
                    case 1:
                        _j.trys.push([1, 5, , 6]);
                        peerId = void 0;
                        if (!peerIdObj) return [3 /*break*/, 3];
                        return [4 /*yield*/, createFromJSON(peerIdObj)];
                    case 2:
                        peerId = _j.sent();
                        _j.label = 3;
                    case 3:
                        webRTCSignal = {};
                        if (this._webRTCSignallingEnabled) {
                            relayPeerIdString = this._relayNodeMultiaddr.getPeerId();
                            assert(relayPeerIdString);
                            webRTCSignal = {
                                enabled: true,
                                isSignallingNode: false,
                                autoSignal: {
                                    enabled: true,
                                    relayPeerId: relayPeerIdString
                                }
                            };
                        }
                        _h = this;
                        return [4 /*yield*/, createLibp2p({
                                peerId: peerId,
                                transports: __spreadArray([
                                    webSockets({
                                        filter: wsPeerFilter
                                    })
                                ], __read(((_b = initOptions.transports) !== null && _b !== void 0 ? _b : [])), false),
                                addresses: {
                                    listen: (_c = initOptions.listenMultiaddrs) !== null && _c !== void 0 ? _c : []
                                },
                                connectionEncryption: [noise()],
                                streamMuxers: [mplex(), yamux()],
                                pubsub: initPubsub(initOptions.pubsub, initOptions.directPeers),
                                peerDiscovery: __spreadArray([
                                    // Use pubsub based discovery; relay server acts as a peer discovery source
                                    pubsubPeerDiscovery({
                                        interval: PUBSUB_DISCOVERY_INTERVAL
                                    })
                                ], __read(((_d = initOptions.peerDiscovery) !== null && _d !== void 0 ? _d : [])), false),
                                relay: {
                                    enabled: true,
                                    autoRelay: {
                                        enabled: true,
                                        maxListeners: 2
                                    }
                                },
                                webRTCSignal: webRTCSignal,
                                connectionManager: {
                                    maxDialsPerPeer: MAX_CONCURRENT_DIALS_PER_PEER,
                                    autoDial: false,
                                    deny: initOptions.denyMultiaddrs,
                                    maxConnections: (_e = initOptions.maxConnections) !== null && _e !== void 0 ? _e : MAX_CONNECTIONS,
                                    minConnections: (_f = initOptions.minConnections) !== null && _f !== void 0 ? _f : MIN_CONNECTIONS,
                                    dialTimeout: (_g = initOptions.dialTimeout) !== null && _g !== void 0 ? _g : DIAL_TIMEOUT,
                                    keepMultipleConnections: true // Set true to get connections with multiple multiaddr
                                },
                                ping: {
                                    timeout: pingTimeout
                                },
                                metrics: function () { return _this._metrics; }
                            })];
                    case 4:
                        _h._node = _j.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        err_1 = _j.sent();
                        log('Could not initialize a libp2p node', err_1);
                        return [2 /*return*/];
                    case 6:
                        log('libp2p node created', this._node);
                        this._peerHeartbeatChecker = new PeerHearbeatChecker(this._node, {
                            pingInterval: initOptions.pingInterval,
                            pingTimeout: pingTimeout
                        });
                        // Dial to the HOP enabled primary relay node
                        return [4 /*yield*/, this._dialRelay(this._relayRedialInterval)];
                    case 7:
                        // Dial to the HOP enabled primary relay node
                        _j.sent();
                        // Listen for change in stored multiaddrs
                        this._node.peerStore.addEventListener('change:multiaddrs', function (evt) {
                            assert(_this._node);
                            var _a = evt.detail, peerId = _a.peerId, multiaddrs = _a.multiaddrs;
                            // Log updated self multiaddrs
                            if (peerId.equals(_this._node.peerId)) {
                                log('Updated self multiaddrs', _this._node.getMultiaddrs().map(function (addr) { return addr.toString(); }));
                            }
                            else {
                                log('Updated peer node multiaddrs', multiaddrs.map(function (addr) { return addr.toString(); }));
                            }
                        });
                        // Listen for change in peer protocols
                        this._node.peerStore.addEventListener('change:protocols', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        assert(this._node);
                                        log('event change:protocols', evt);
                                        return [4 /*yield*/, this._handleChangeProtocols(evt.detail)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        // Listen for peers discovery
                        this._node.addEventListener('peer:discovery', function (evt) {
                            // log('event peer:discovery', evt);
                            _this._handleDiscovery(evt.detail, _this._maxRelayConnections);
                        });
                        // Listen for peers connection
                        this._node.addEventListener('peer:connect', function (evt) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: 
                                    // log('event peer:connect', evt);
                                    return [4 /*yield*/, this._handleConnect(evt.detail, this._maxRelayConnections)];
                                    case 1:
                                        // log('event peer:connect', evt);
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        // Listen for peers disconnecting
                        // peer:disconnect event is trigerred when all connections to a peer close
                        // https://github.com/libp2p/js-libp2p-interfaces/blob/master/packages/interface-libp2p/src/index.ts#L64
                        this._node.addEventListener('peer:disconnect', function (evt) {
                            // log('event peer:disconnect', evt);
                            _this._handleDisconnect(evt.detail);
                        });
                        // Handle messages for the protocol
                        return [4 /*yield*/, this._node.handle(CHAT_PROTOCOL, function (_a) {
                                var stream = _a.stream, connection = _a.connection;
                                return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_b) {
                                        this._handleStream(connection.remotePeer, stream);
                                        return [2 /*return*/];
                                    });
                                });
                            })];
                    case 8:
                        // Handle messages for the protocol
                        _j.sent();
                        // Listen for pubsub messages
                        this._node.pubsub.addEventListener('message', function (evt) {
                            _this._handlePubSubMessage(evt.detail);
                        });
                        if (this._debugInfoEnabled) {
                            log('Debug info enabled');
                            this._registerDebugInfoRequestHandler();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remotePeerIds, hangUpPromises;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        this._node.peerStore.removeEventListener('change:multiaddrs');
                        this._node.removeEventListener('peer:discovery');
                        this._node.removeEventListener('peer:connect');
                        this._node.removeEventListener('peer:disconnect');
                        this._node.peerStore.removeEventListener('change:multiaddrs');
                        this._node.peerStore.removeEventListener('change:protocols');
                        this._node.pubsub.removeEventListener('message');
                        return [4 /*yield*/, this._node.unhandle(CHAT_PROTOCOL)];
                    case 1:
                        _a.sent();
                        remotePeerIds = this._node.getPeers();
                        remotePeerIds.forEach(function (remotePeerId) { var _a; return (_a = _this._peerHeartbeatChecker) === null || _a === void 0 ? void 0 : _a.stop(remotePeerId); });
                        hangUpPromises = remotePeerIds.map(function (peerId) { return __awaiter(_this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                            return [2 /*return*/, (_a = this._node) === null || _a === void 0 ? void 0 : _a.hangUp(peerId)];
                        }); }); });
                        return [4 /*yield*/, Promise.all(hangUpPromises)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.getInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var selfInfo, connInfo, metrics;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this.node);
                        assert(this.peerId);
                        selfInfo = this.getPeerSelfInfo();
                        connInfo = this.getPeerConnectionsInfo();
                        return [4 /*yield*/, this.metrics.getMetricsAsMap()];
                    case 1:
                        metrics = _a.sent();
                        return [2 /*return*/, {
                                selfInfo: selfInfo,
                                connInfo: connInfo,
                                metrics: metrics
                            }];
                }
            });
        });
    };
    Peer.prototype.getPeerSelfInfo = function () {
        assert(this._node);
        var selfInfo = getSelfInfo(this._node);
        return __assign(__assign({}, selfInfo), { primaryRelayMultiaddr: this.relayNodeMultiaddr.toString(), primaryRelayPeerId: this.relayNodeMultiaddr.getPeerId() });
    };
    Peer.prototype.getPeerConnectionsInfo = function () {
        var _this = this;
        assert(this._node);
        assert(this._peerHeartbeatChecker);
        var connectionsInfo = getConnectionsInfo(this._node, this._peerHeartbeatChecker);
        return connectionsInfo.map(function (connectionInfo) {
            var peerConnectionInfo = __assign(__assign({}, connectionInfo), { isPeerRelay: _this.isRelayPeerMultiaddr(connectionInfo.multiaddr), isPeerRelayPrimary: _this.isPrimaryRelay(connectionInfo.multiaddr) });
            if (peerConnectionInfo.type === ConnectionType.Relayed) {
                peerConnectionInfo.hopRelayPeerId = multiaddr(peerConnectionInfo.multiaddr).decapsulate('p2p-circuit/p2p').getPeerId();
            }
            return peerConnectionInfo;
        });
    };
    Peer.prototype.broadcastMessage = function (message) {
        var e_1, _a;
        try {
            for (var _b = __values(this._peerStreamMap), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), stream = _d[1];
                stream.push(message);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    Peer.prototype.floodMessage = function (topic, msg) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        return [4 /*yield*/, this._node.pubsub.publish(topic, uint8ArrayFromString(JSON.stringify(msg)))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.requestPeerInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var request;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        if (!this._debugInfoEnabled) {
                            throw new Error(ERR_DEBUG_INFO_NOT_ENABLED);
                        }
                        request = { type: 'Request' };
                        return [4 /*yield*/, this.floodMessage(DEBUG_INFO_TOPIC, request)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype.subscribeMessage = function (handler) {
        var _this = this;
        this._messageHandlers.push(handler);
        var unsubscribe = function () {
            _this._messageHandlers = _this._messageHandlers
                .filter(function (registeredHandler) { return registeredHandler !== handler; });
        };
        return unsubscribe;
    };
    Peer.prototype.subscribeTopic = function (topic, handler) {
        var _this = this;
        var _a;
        assert(this._node);
        // Subscribe node to the topic
        this._node.pubsub.subscribe(topic);
        // Register provided handler for the topic
        if (!this._topicHandlers.has(topic)) {
            this._topicHandlers.set(topic, [handler]);
        }
        else {
            (_a = this._topicHandlers.get(topic)) === null || _a === void 0 ? void 0 : _a.push(handler);
        }
        // Create a unsubscribe callback
        var unsubscribe = function () {
            var _a, _b;
            // Remove handler from registered handlers for the topic
            var filteredTopicHandlers = (_a = _this._topicHandlers.get(topic)) === null || _a === void 0 ? void 0 : _a.filter(function (registeredHandler) { return registeredHandler !== handler; });
            if (filteredTopicHandlers === null || filteredTopicHandlers === void 0 ? void 0 : filteredTopicHandlers.length) {
                _this._topicHandlers.set(topic, filteredTopicHandlers);
            }
            else {
                // Remove topic from map and unsubscribe node from the topic if no handlers left
                _this._topicHandlers.delete(topic);
                (_b = _this._node) === null || _b === void 0 ? void 0 : _b.pubsub.unsubscribe(topic);
            }
        };
        return unsubscribe;
    };
    Peer.prototype.subscribeDebugInfo = function (handler) {
        if (!this._debugInfoEnabled) {
            throw new Error(ERR_DEBUG_INFO_NOT_ENABLED);
        }
        return this.subscribeTopic(DEBUG_INFO_TOPIC, handler);
    };
    Peer.prototype.isRelayPeerMultiaddr = function (multiaddrString) {
        // Multiaddr not having p2p-circuit id or webrtc-star id is of a relay node
        return !(multiaddrString.includes(P2P_CIRCUIT_ID) || multiaddrString.includes(P2P_WEBRTC_STAR_ID));
    };
    Peer.prototype.isPrimaryRelay = function (multiaddrString) {
        return multiaddrString === this._relayNodeMultiaddr.toString();
    };
    Peer.prototype.getLatencyData = function (peerId) {
        if (this._peerHeartbeatChecker) {
            return this._peerHeartbeatChecker.getLatencyData(peerId);
        }
        return [];
    };
    Peer.prototype._handleChangeProtocols = function (_a) {
        var peerId = _a.peerId, protocols = _a.protocols;
        return __awaiter(this, void 0, void 0, function () {
            var _b, connection;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        assert(this._node);
                        // Ignore self protocol changes
                        if (peerId.equals(this._node.peerId)) {
                            return [2 /*return*/];
                        }
                        // Ignore if chat protocol is not handled by remote peer
                        if (!protocols.includes(CHAT_PROTOCOL)) {
                            return [2 /*return*/];
                        }
                        // Handle protocol and open stream from only one side
                        if (this._node.peerId.toString() > peerId.toString()) {
                            return [2 /*return*/];
                        }
                        _b = __read(this._node.getConnections(peerId), 1), connection = _b[0];
                        if (!(connection && !connection.streams.some(function (stream) { return stream.stat.protocol === CHAT_PROTOCOL; }))) return [3 /*break*/, 2];
                        return [4 /*yield*/, this._createProtocolStream(connection, CHAT_PROTOCOL)];
                    case 1:
                        _c.sent();
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._dialRelay = function (redialInterval) {
        if (redialInterval === void 0) { redialInterval = RELAY_REDIAL_INTERVAL; }
        return __awaiter(this, void 0, void 0, function () {
            var relayMultiaddr, connection, relayPeerId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        relayMultiaddr = this._relayNodeMultiaddr;
                        log('Dialling primary relay node');
                        return [4 /*yield*/, dialWithRetry(this._node, relayMultiaddr, {
                                redialInterval: redialInterval,
                                maxRetry: Infinity
                            })];
                    case 1:
                        connection = _a.sent();
                        relayPeerId = connection.remotePeer;
                        // Tag the relay node with a high value to prioritize it's connection
                        // in connection pruning on crossing peer's maxConnections limit
                        this._node.peerStore.tagPeer(relayPeerId, RELAY_TAG.tag, { value: RELAY_TAG.value }).catch(function (err) {
                            // TODO: Check if tag already exists
                            // If awaited on the getTags / tagPeer method, relay node connect event is not triggered
                            // const peerTags = await this._node.peerStore.getTags(relayPeerId);
                            // Ignore the error thrown on retagging a peer on reconnect
                            if (err.message === ERR_PEER_ALREADY_TAGGED) {
                                return;
                            }
                            throw err;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleDiscovery = function (peer, maxRelayConnections) {
        var e_2, _a;
        var _b, _c;
        if (maxRelayConnections === void 0) { maxRelayConnections = DEFAULT_MAX_RELAY_CONNECTIONS; }
        // Check connected peers as they are discovered repeatedly.
        if ((_b = this._node) === null || _b === void 0 ? void 0 : _b.getPeers().some(function (remotePeerId) { return remotePeerId.toString() === peer.id.toString(); })) {
            return;
        }
        var isRelayPeer = false;
        try {
            for (var _d = __values(peer.multiaddrs), _e = _d.next(); !_e.done; _e = _d.next()) {
                var multiaddr_1 = _e.value;
                if (isMultiaddrBlacklisted((_c = this._denyMultiaddrs) !== null && _c !== void 0 ? _c : [], multiaddr_1)) {
                    log("Ignoring blacklisted node with multiaddr ".concat(multiaddr_1.toString()));
                    return;
                }
                if (this.isRelayPeerMultiaddr(multiaddr_1.toString())) {
                    isRelayPeer = true;
                    break;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // Check relay connections limit if it's a relay peer
        if (isRelayPeer && this._numRelayConnections >= maxRelayConnections) {
            // log(`Ignoring discovered relay node ${peer.id.toString()} as max relay connections limit reached`);
            return;
        }
        log("Discovered peer ".concat(peer.id.toString(), " (").concat(getPseudonymForPeerId(peer.id.toString()), ") with multiaddrs"), peer.multiaddrs.map(function (addr) { return addr.toString(); }));
        this._connectPeer(peer);
    };
    Peer.prototype._handleConnect = function (connection, maxRelayConnections) {
        var _a;
        if (maxRelayConnections === void 0) { maxRelayConnections = DEFAULT_MAX_RELAY_CONNECTIONS; }
        return __awaiter(this, void 0, void 0, function () {
            var remotePeerId, remotePeerIdString, remoteAddrString, isRemoteARelayPeer, remoteConnections, closeConnectionPromises, protocols;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        assert(this._node);
                        remotePeerId = connection.remotePeer;
                        remotePeerIdString = connection.remotePeer.toString();
                        remoteAddrString = connection.remoteAddr.toString();
                        // Log connected peer
                        log("Connected to ".concat(remotePeerIdString, " (").concat(getPseudonymForPeerId(remotePeerIdString), ") using multiaddr ").concat(remoteAddrString));
                        isRemoteARelayPeer = this.isRelayPeerMultiaddr(remoteAddrString);
                        if (!isRemoteARelayPeer) return [3 /*break*/, 2];
                        this._numRelayConnections++;
                        if (!(this._numRelayConnections > maxRelayConnections && !this.isPrimaryRelay(remoteAddrString))) return [3 /*break*/, 2];
                        log("Closing connection to relay ".concat(remotePeerIdString, " (").concat(getPseudonymForPeerId(remotePeerIdString), ") as max relay connections limit reached"));
                        return [4 /*yield*/, connection.close()];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                    case 2:
                        if (!(isRemoteARelayPeer || this._node.peerId.toString() < remotePeerIdString)) return [3 /*break*/, 9];
                        remoteConnections = this._node.getConnections(remotePeerId);
                        if (!(remoteConnections.length > 1)) return [3 /*break*/, 6];
                        if (!connection.remoteAddr.protoNames().includes(P2P_CIRCUIT_ID)) return [3 /*break*/, 4];
                        log("Closing new relayed connection with ".concat(remotePeerIdString, " (").concat(getPseudonymForPeerId(remotePeerIdString), ") in favor of existing connection"));
                        return [4 /*yield*/, connection.close()];
                    case 3:
                        _b.sent();
                        log('Closed');
                        return [2 /*return*/];
                    case 4:
                        log("Closing exisiting connections with ".concat(remotePeerIdString, " (").concat(getPseudonymForPeerId(remotePeerIdString), ") in favor of new webrtc connection"));
                        closeConnectionPromises = remoteConnections.filter(function (remoteConnection) { return remoteConnection.id !== connection.id; })
                            .map(function (remoteConnection) { return remoteConnection.close(); });
                        return [4 /*yield*/, Promise.all(closeConnectionPromises)];
                    case 5:
                        _b.sent();
                        log('Closed');
                        _b.label = 6;
                    case 6: return [4 /*yield*/, this._node.peerStore.protoBook.get(remotePeerId)];
                    case 7:
                        protocols = _b.sent();
                        if (!protocols.includes(CHAT_PROTOCOL)) return [3 /*break*/, 9];
                        return [4 /*yield*/, this._createProtocolStream(connection, CHAT_PROTOCOL)];
                    case 8:
                        _b.sent();
                        _b.label = 9;
                    case 9:
                        log("Current number of peers connected: ".concat(this._node.getPeers().length));
                        // Start heartbeat check for peer
                        return [4 /*yield*/, ((_a = this._peerHeartbeatChecker) === null || _a === void 0 ? void 0 : _a.start(remotePeerId, function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2 /*return*/, this._handleDeadConnections(remotePeerId)];
                            }); }); }))];
                    case 10:
                        // Start heartbeat check for peer
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._createProtocolStream = function (connection, protocol) {
        return __awaiter(this, void 0, void 0, function () {
            var remotePeerId, stream, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        remotePeerId = connection.remotePeer;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, connection.newStream([protocol])];
                    case 2:
                        stream = _a.sent();
                        this._handleStream(remotePeerId, stream);
                        return [3 /*break*/, 4];
                    case 3:
                        err_2 = _a.sent();
                        log("Could not create a new ".concat(protocol, " stream with ").concat(remotePeerId.toString(), " (").concat(getPseudonymForPeerId(remotePeerId.toString()), ")"), err_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleDeadConnections = function (remotePeerId) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // Close existing connections of remote peer
                        log("Closing connections for ".concat(remotePeerId, " (").concat(getPseudonymForPeerId(remotePeerId.toString()), ")"));
                        return [4 /*yield*/, ((_a = this._node) === null || _a === void 0 ? void 0 : _a.hangUp(remotePeerId))];
                    case 1:
                        _b.sent();
                        log('Closed');
                        return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleDisconnect = function (connection) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var disconnectedPeerId, remoteAddrString;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        assert(this._node);
                        disconnectedPeerId = connection.remotePeer;
                        remoteAddrString = connection.remoteAddr.toString();
                        // Log disconnected peer
                        log("Disconnected from ".concat(disconnectedPeerId.toString(), " (").concat(getPseudonymForPeerId(disconnectedPeerId.toString()), ") using multiaddr ").concat(remoteAddrString));
                        log("Current number of peers connected: ".concat((_a = this._node) === null || _a === void 0 ? void 0 : _a.getPeers().length));
                        if (this.isRelayPeerMultiaddr(remoteAddrString)) {
                            this._numRelayConnections--;
                        }
                        // Stop connection check for disconnected peer
                        (_b = this._peerHeartbeatChecker) === null || _b === void 0 ? void 0 : _b.stop(disconnectedPeerId);
                        if (!(disconnectedPeerId.toString() === ((_c = this._relayNodeMultiaddr) === null || _c === void 0 ? void 0 : _c.getPeerId()))) return [3 /*break*/, 2];
                        // Reconnect to primary relay node if disconnected
                        return [4 /*yield*/, this._dialRelay(this._relayRedialInterval)];
                    case 1:
                        // Reconnect to primary relay node if disconnected
                        _d.sent();
                        _d.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._connectPeer = function (peer) {
        return __awaiter(this, void 0, void 0, function () {
            var peerIdString, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        peerIdString = peer.id.toString();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        log("Dialling peer ".concat(peerIdString, " (").concat(getPseudonymForPeerId(peerIdString), ")"));
                        // When dialling with peer id, all multiaddr(s) (direct/relayed) of the discovered peer are dialled in parallel
                        return [4 /*yield*/, this._node.dial(peer.id)];
                    case 2:
                        // When dialling with peer id, all multiaddr(s) (direct/relayed) of the discovered peer are dialled in parallel
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_3 = _a.sent();
                        log("Could not dial ".concat(peerIdString, " (").concat(getPseudonymForPeerId(peerIdString), ")"), err_3);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Peer.prototype._handleStream = function (peerId, stream) {
        var _this = this;
        // log('Stream after connection', stream);
        var messageStream = pushable({ objectMode: true });
        // Send message to pipe from stdin
        pipe(
        // Read from stream (the source)
        messageStream, 
        // Turn objects into buffers
        function (source) { return map(source, function (value) {
            return uint8ArrayFromString(JSON.stringify(value));
        }); }, 
        // Encode with length prefix (so receiving side knows how much data is coming)
        lp.encode(), 
        // Write to the stream (the sink)
        stream.sink);
        // Handle message from stream
        pipe(
        // Read from the stream (the source)
        stream.source, 
        // Decode length-prefixed data
        lp.decode(), 
        // Turn buffers into objects
        function (source) { return map(source, function (buf) {
            return JSON.parse(uint8ArrayToString(buf.subarray()));
        }); }, 
        // Sink function
        function (source) { var _a, source_1, source_1_1; return __awaiter(_this, void 0, void 0, function () {
            var _loop_1, this_1, e_3_1;
            var _b, e_3, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 5, 6, 11]);
                        _loop_1 = function () {
                            _d = source_1_1.value;
                            _a = false;
                            try {
                                var msg = _d;
                                this_1._messageHandlers.forEach(function (messageHandler) { return messageHandler(peerId, msg); });
                            }
                            finally {
                                _a = true;
                            }
                        };
                        this_1 = this;
                        _a = true, source_1 = __asyncValues(source);
                        _e.label = 1;
                    case 1: return [4 /*yield*/, source_1.next()];
                    case 2:
                        if (!(source_1_1 = _e.sent(), _b = source_1_1.done, !_b)) return [3 /*break*/, 4];
                        _loop_1();
                        _e.label = 3;
                    case 3: return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 11];
                    case 5:
                        e_3_1 = _e.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 11];
                    case 6:
                        _e.trys.push([6, , 9, 10]);
                        if (!(!_a && !_b && (_c = source_1.return))) return [3 /*break*/, 8];
                        return [4 /*yield*/, _c.call(source_1)];
                    case 7:
                        _e.sent();
                        _e.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        if (e_3) throw e_3.error;
                        return [7 /*endfinally*/];
                    case 10: return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        }); });
        // TODO: Check if stream already exists for peer id
        this._peerStreamMap.set(peerId.toString(), messageStream);
    };
    Peer.prototype._handlePubSubMessage = function (msg) {
        var _a;
        // Messages should be signed since globalSignaturePolicy is set to 'StrictSign'
        assert(msg.type === 'signed');
        // Send msg data to registered topic handlers
        (_a = this._topicHandlers.get(msg.topic)) === null || _a === void 0 ? void 0 : _a.forEach(function (handler) {
            var dataObj = JSON.parse(uint8ArrayToString(msg.data));
            handler(msg.from, dataObj);
        });
    };
    Peer.prototype._registerDebugInfoRequestHandler = function () {
        var _this = this;
        this.subscribeTopic(DEBUG_INFO_TOPIC, function (peerId, msg) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assert(this._node);
                        return [4 /*yield*/, debugInfoRequestHandler({
                                node: this._node,
                                getPeerInfo: this.getInfo.bind(this),
                                peerId: peerId,
                                msg: msg
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return Peer;
}());
export { Peer };
export function createPeerId() {
    return __awaiter(this, void 0, void 0, function () {
        var peerId;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, createEd25519PeerId()];
                case 1:
                    peerId = _a.sent();
                    assert(peerId.privateKey);
                    return [2 /*return*/, {
                            id: peerId.toString(),
                            privKey: Buffer.from(peerId.privateKey).toString('base64'),
                            pubKey: Buffer.from(peerId.publicKey).toString('base64')
                        }];
            }
        });
    });
}
//# sourceMappingURL=peer.js.map