/* eslint-disable no-unused-expressions */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as dotenv from 'dotenv';
import path from 'path';
import 'mocha';
import assert from 'assert';
import { expect } from 'chai';
import { pEvent } from 'p-event';
import debug from 'debug';
import { multiaddr } from '@multiformats/multiaddr';
import { Peer } from './peer.js';
var log = debug('laconic:test');
var PEER_CONNECTION_TIMEOUT = 15 * 1000; // 15s
// Get relay node address from the .env file
dotenv.config({ path: path.resolve('./.env') });
describe('basic p2p tests', function () {
    var peers;
    var relayMultiAddr = process.env.RELAY;
    it('peers get initialized', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    assert(relayMultiAddr, 'Relay multiaddr not provided');
                    peers = [
                        new Peer(relayMultiAddr, true),
                        new Peer(relayMultiAddr, true)
                    ];
                    return [4 /*yield*/, Promise.all(peers.map(function (peer) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, peer.init({})];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('peers get connected to the primary relay node', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Promise.all(peers.map(function (peer) { return __awaiter(void 0, void 0, void 0, function () {
                        var connections, expectedPeerId, connectedPeerIds;
                        var _a;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    assert(peer.node);
                                    // Wait for a connection to be established
                                    return [4 /*yield*/, pEvent(peer.node, 'peer:connect')];
                                case 1:
                                    // Wait for a connection to be established
                                    _b.sent();
                                    connections = peer.node.getConnections();
                                    assert(connections, 'No peer connections found');
                                    expectedPeerId = (_a = multiaddr(relayMultiAddr).getPeerId()) === null || _a === void 0 ? void 0 : _a.toString();
                                    connectedPeerIds = connections === null || connections === void 0 ? void 0 : connections.map(function (connection) { return connection.remotePeer.toString(); });
                                    expect(connectedPeerIds).to.include(expectedPeerId);
                                    return [2 /*return*/];
                            }
                        });
                    }); }))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('peers discover and get connected to each other', function () { return __awaiter(void 0, void 0, void 0, function () {
        var connectionPromises;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    connectionPromises = peers.map(function (peer, index) { return __awaiter(void 0, void 0, void 0, function () {
                        var otherPeersId;
                        var _a;
                        return __generator(this, function (_b) {
                            assert(peer.node);
                            otherPeersId = (_a = peers[1 - index].node) === null || _a === void 0 ? void 0 : _a.peerId.toString();
                            return [2 /*return*/, new Promise(function (resolve, reject) {
                                    var _a, _b;
                                    // Resolve if already connected to the other peer
                                    var alreadyConnected = (_a = peer.node) === null || _a === void 0 ? void 0 : _a.getPeers().some(function (peerId) { return peerId.toString() === otherPeersId; });
                                    if (alreadyConnected) {
                                        resolve();
                                    }
                                    (_b = peer.node) === null || _b === void 0 ? void 0 : _b.addEventListener('peer:connect', function (event) { return __awaiter(void 0, void 0, void 0, function () {
                                        var connection;
                                        return __generator(this, function (_a) {
                                            connection = event.detail;
                                            // Resolve after getting connected to the other peer
                                            if (connection.remotePeer.toString() === otherPeersId) {
                                                resolve();
                                            }
                                            return [2 /*return*/];
                                        });
                                    }); });
                                    setTimeout(function () {
                                        reject(new Error('Peer connection timed out'));
                                    }, PEER_CONNECTION_TIMEOUT);
                                })];
                        });
                    }); });
                    return [4 /*yield*/, Promise.all(connectionPromises)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('peers are able to communicate over a topic', function () { return __awaiter(void 0, void 0, void 0, function () {
        var pubSubTopic, msgFromPeer1, msgFromPeer2, messageReceivedByPeer1, messageReceivedByPeer2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pubSubTopic = 'dummy-topic';
                    msgFromPeer1 = 'Hello from peer1';
                    msgFromPeer2 = 'Hello from peer2';
                    messageReceivedByPeer1 = false;
                    messageReceivedByPeer2 = false;
                    peers[0].subscribeTopic(pubSubTopic, function (peerId, data) {
                        if (data === msgFromPeer2) {
                            messageReceivedByPeer1 = true;
                        }
                        log("".concat(peerId.toString(), " > ").concat(data));
                    });
                    peers[1].subscribeTopic(pubSubTopic, function (peerId, data) {
                        if (data === msgFromPeer1) {
                            messageReceivedByPeer2 = true;
                        }
                        log("".concat(peerId.toString(), " > ").concat(data));
                    });
                    // Wait for the connection between peers to be stabilized
                    // Peers upgrade to a direct connection from a relayed one if possible
                    return [4 /*yield*/, sleep(3000)];
                case 1:
                    // Wait for the connection between peers to be stabilized
                    // Peers upgrade to a direct connection from a relayed one if possible
                    _a.sent();
                    peers[0].floodMessage(pubSubTopic, msgFromPeer1);
                    peers[1].floodMessage(pubSubTopic, msgFromPeer2);
                    return [4 /*yield*/, sleep(2000)];
                case 2:
                    _a.sent();
                    expect(messageReceivedByPeer1).to.be.true;
                    expect(messageReceivedByPeer2).to.be.true;
                    return [2 /*return*/];
            }
        });
    }); });
    after('cleanup', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            // Doing peer.close() runs into the following error:
            //  Pure virtual function called!
            //  Aborted (core dumped)
            // So just exit the process to stop the peers
            process.exit(0);
            return [2 /*return*/];
        });
    }); });
});
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
//# sourceMappingURL=peer.test.js.map